diff --git a/src/CSLib/CSLib_Class2d.cxx b/src/CSLib/CSLib_Class2d.cxx
index 35e84cb..bd78287 100644
--- a/src/CSLib/CSLib_Class2d.cxx
+++ b/src/CSLib/CSLib_Class2d.cxx
@@ -19,306 +19,373 @@
 #include <CSLib_Class2d.hxx>
 #include <gp_Pnt2d.hxx>
 #include <Standard_ConstructionError.hxx>
+#include <Precision.hxx>
+
+static inline Standard_Boolean IsOn(const Standard_Real theTolU,
+                                    const Standard_Real theTolV,
+                                    const Standard_Real thePrevX,
+                                    const Standard_Real thePrevY,
+                                    const Standard_Real theDx,
+                                    const Standard_Real theDy);
 
-static inline 
-  Standard_Real Transform2d(const Standard_Real u,
-			    const Standard_Real umin,
-			    const Standard_Real umaxmumin);
 
 //=======================================================================
-//function : CSLib_Class2d
+//function : Constructor
 //purpose  : 
 //=======================================================================
-CSLib_Class2d::CSLib_Class2d(const TColgp_Array1OfPnt2d& TP2d,
-			     const Standard_Real aTolu,
-			     const Standard_Real aTolv,
-			     const Standard_Real umin,
-			     const Standard_Real vmin,
-			     const Standard_Real umax,
-			     const Standard_Real vmax) 
+CSLib_Class2d::CSLib_Class2d(const TColgp_Array1OfPnt2d& theTP2d,
+                             const Standard_Real theTolu,
+                             const Standard_Real theTolv,
+                             const Standard_Real theUmin,
+                             const Standard_Real theVmin,
+                             const Standard_Real theUmax,
+                             const Standard_Real theVmax) : myPnts2d(0,
+                                                                theTP2d.Length()),
+                                                            myTolU(theTolu),
+                                                            myTolV(theTolv),
+                                                            myUmin(theUmin),
+                                                            myUmax(theUmax),
+                                                            myVmin(theVmin),
+                                                            myVmax(theVmax)
 {
-  Umin=umin;
-  Vmin=vmin;
-  Umax=umax;
-  Vmax=vmax;
-  //
-  if(umax<=umin || vmax<=vmin) { 
-    MyPnts2dX=NULL;
-    MyPnts2dY=NULL;
-    N=0;
+  const size_t aN = theTP2d.Length();
+  if((theUmax <= theUmin) || (theVmax <= theVmin) || (aN == 0))
+  {
+    // Nothing will be created.
+    return;
   }
-  //
-  else {
-    Standard_Integer i, iLower;
-    Standard_Real du,dv,*Pnts2dX,*Pnts2dY, aPrc;   
-    //
-    aPrc=1.e-10;
-    N = TP2d.Length();
-    Tolu = aTolu;
-    Tolv = aTolv;
-    MyPnts2dX = new Standard_Real [N+1];
-    MyPnts2dY = new Standard_Real [N+1];
-    du=umax-umin;
-    dv=vmax-vmin;
-    Pnts2dX = (Standard_Real *)MyPnts2dX;
-    Pnts2dY = (Standard_Real *)MyPnts2dY;
-    //
-    iLower=TP2d.Lower();
-    for(i = 0; i<N; ++i) { 
-      const gp_Pnt2d& aP2D=TP2d(i+iLower);
-      Pnts2dX[i] = Transform2d(aP2D.X(), umin, du);
-      Pnts2dY[i] = Transform2d(aP2D.Y(), vmin, dv);
-    }
-    Pnts2dX[N]=Pnts2dX[0];
-    Pnts2dY[N]=Pnts2dY[0];
-    //
-    if(du>aPrc) {
-      Tolu/=du;
+
+  myTolU = Max(myTolU, Precision::PConfusion());
+  myTolV = Max(myTolV, Precision::PConfusion());
+
+  // The classification algorithm works incorrectly
+  // some segment(s) of the polygon has null length.
+  // The code below forbids creation of such polygons.
+
+  Standard_Integer aCurrIdx = myPnts2d.Lower();
+  gp_Pnt2d aPPrev = theTP2d(theTP2d.Lower());
+  myPnts2d(aCurrIdx).SetCoord(aPPrev.X() - theUmin, aPPrev.Y() - theVmin);
+  for (Standard_Integer i = theTP2d.Lower() + 1; i < theTP2d.Upper(); ++i)
+  {
+    const gp_Pnt2d& aPCur = theTP2d(i);
+
+    if (aPPrev.SquareDistance(aPCur) < gp::Resolution())
+    {
+      continue;
     }
-    if(dv>aPrc) {
-      Tolv/=dv;
+
+    myPnts2d(++aCurrIdx).SetCoord(aPCur.X() - theUmin, aPCur.Y() - theVmin);
+    aPPrev = aPCur;
+  }
+
+  {
+    aPPrev = theTP2d(theTP2d.Lower());
+    const gp_Pnt2d& aPCur = theTP2d(theTP2d.Upper());
+
+    if (aPPrev.SquareDistance(aPCur) > 0.0)
+    {
+      // I.e. SquareDistance(...) != 0
+
+      myPnts2d(++aCurrIdx).SetCoord(aPCur.X() - theUmin, aPCur.Y() - theVmin);
     }
+
+    myPnts2d(++aCurrIdx).SetCoord(aPPrev.X() - theUmin, aPPrev.Y() - theVmin);
+  }
+
+  if (aCurrIdx < myPnts2d.Upper())
+  {
+    myPnts2d.Resize(myPnts2d.Lower(), aCurrIdx, Standard_True);
   }
 }
+
 //=======================================================================
-//function : Destroy
+//function : Classify
 //purpose  : 
 //=======================================================================
-void CSLib_Class2d::Destroy() { 
-  if(MyPnts2dX) { 
-    delete [] (Standard_Real *)MyPnts2dX;
-    MyPnts2dX=NULL;
-  }
-  if(MyPnts2dY) { 
-    delete [] (Standard_Real *)MyPnts2dY;
-    MyPnts2dY=NULL;
-  }
+CSLib_Class2d::PolyState CSLib_Class2d::Classify(const gp_Pnt2d& theP) const
+{
+  return Classify(theP, myTolU, myTolV);
 }
 
-//-- Attention   Table of 0 ------> N + 1 
-//--                      P1 ..... Pn P1
-//--
-//--     1  2  3
-//--     4  0  5
-//--     6  7  8
-//-- 
 //=======================================================================
-//function : SiDans
+//function : Classify
 //purpose  : 
 //=======================================================================
-Standard_Integer CSLib_Class2d::SiDans(const gp_Pnt2d& P) const
+CSLib_Class2d::PolyState CSLib_Class2d::Classify(const gp_Pnt2d& theP,
+                                                 const Standard_Real theTolU,
+                                                 const Standard_Real theTolV) const
 { 
-  if(!N) {
-    return 0;
+  if ((myPnts2d.Size() < 3) || (myUmin > myUmax) || (myVmin > myVmax))
+  {
+    // Return 0 for compatibility with
+    // previous versions of OCCT (it does not
+    // mean that the status is ON).
+
+#ifdef OCCT_DEBUG
+    std::cout << "CSLib_Class2d::Classify(...). No polygon "
+                 "for classification!" << std::endl;
+#endif
+
+    return (PolyState)0;
   }
   //
-  Standard_Real x,y, aTolu, aTolv;
-  //
-  x = P.X(); y = P.Y();
-  aTolu=Tolu*(Umax-Umin);
-  aTolv=Tolv*(Vmax-Vmin);
-  //
-  if(Umin<Umax && Vmin<Vmax)    {
-    if( ( x<(Umin-aTolu) ) || 
-       ( x>(Umax+aTolu) ) || 
-       ( y<(Vmin-aTolv) ) || 
-       ( y>(Vmax+aTolv) ) ) {
-      return -1;
-    }
-    x=Transform2d(x,Umin,Umax-Umin);
-    y=Transform2d(y,Vmin,Vmax-Vmin);
+  Standard_Real aX = theP.X(), aY = theP.Y();
+  if ((theTolU < (myUmin - aX)) ||
+      ((aX - myUmax) > theTolU) ||
+      (theTolV < (myVmin - aY)) ||
+      ((aY - myVmax) > theTolV))
+  {
+    // The point is outside of the UV-bounds
+    return PolyOut;
   }
 
+  aX -= myUmin;
+  aY -= myVmin;
 
-  Standard_Integer res = InternalSiDansOuOn(x,y);
-  if(res==-1) {    
-    return 0;
-  }
-  if(Tolu || Tolv) {
-    if(res != InternalSiDans(x-Tolu,y-Tolv)) return 0;
-    if(res != InternalSiDans(x+Tolu,y-Tolv)) return 0;
-    if(res != InternalSiDans(x-Tolu,y+Tolv)) return 0;
-    if(res != InternalSiDans(x+Tolu,y+Tolv)) return 0; 
-  }
-  //
-  return((res)? 1: -1);
+  return InternalClass(aX, aY, theTolU, theTolV);
 }
+
 //=======================================================================
-//function : SiDans_OnMode
-//purpose  : 
+//function : InternalClass
+//purpose  : Checks if the point P(thePx, thePy) is inside the
+//            given convex polygon.
+//
+// Algorithm description:
+//
+//  1. Catch the moment when some segment of the polygon
+//      intersects the ray from point P in direction {1, 0}.
+//  2. Compute the number of intersections between this ray and
+//      the segments of this polygon.
+//  3. The point P is inside if the number of intersections is even.
+//      The point P is outside if the number of intersections is odd.
+//
+//  This method works wrong in case of tangent the ray with some
+//  segment of polygon. This case must be investigated additionally.
+//  Therefore, the method will return 0 (as ON-status).
+//
+//  ON-status is checked in parallel mode of this algorithm. It is
+//  made by the following steps:
+//
+//  1. A vector V is created joining P with the nearest point of the
+//    considered segment.
+//  2. V is expanded to the two not collinear components: DU and DV.
+//  3. If every coefficient of expanding is less than the corresponding
+//    tolerance (theTolU and theTolV) then the ON-status is returned.
+//
+// ATTENTION!!!
+//  theTolU or/and theTolV can be equal to 0.
 //=======================================================================
-Standard_Integer CSLib_Class2d::SiDans_OnMode(const gp_Pnt2d& P,
-					      const Standard_Real Tol) const
-{ 
-  if(!N){
-    return 0;
-  }
-  //
-  Standard_Real x,y, aTolu, aTolv;
-  //
-  x = P.X(); y = P.Y();
-  aTolu=Tol; 
-  aTolv=Tol; 
-
-  //-- ****** TO DO LATER, ESTIMATE AT EACH POINT Tol2d depending on Tol3d *****
-  if(Umin<Umax && Vmin<Vmax) { 
-    if(x<(Umin-aTolu) || (x>Umax+aTolu) || 
-       (y<Vmin-aTolv) || (y>Vmax+aTolv)) {
-      return -1;
+CSLib_Class2d::PolyState CSLib_Class2d::InternalClass(const Standard_Real thePx,
+                                                      const Standard_Real thePy,
+                                                      const Standard_Real theTolU,
+                                                      const Standard_Real theTolV) const
+{
+#ifdef CSLIB_CLASS2D_DEBUG
+  bool flShow = false;
+
+  if (flShow)
+  {
+    std::cout << "+++ Dump of CSLib_Class2d polygon ++" << std::endl;
+    std::cout << "plane pl 0 0 0 0 0 1" << std::endl;
+    std::cout << "polyclassify -s -c " << thePx+myUmin << " " << thePy + myVmin <<
+                 " -t " << theTolU << " " << theTolV << " ";
+    for (Standard_Integer i = myPnts2d.Lower(); i <= myPnts2d.Upper(); i++)
+    {
+      const gp_Pnt2d &aPCurr = myPnts2d(i);
+      std::cout << "-p " << aPCurr.X() + myUmin << " " << aPCurr.Y() + myVmin << " ";
     }
-    x=Transform2d(x,Umin,Umax-Umin);
-    y=Transform2d(y,Vmin,Vmax-Vmin);
-  }
-  //
-  Standard_Integer res = InternalSiDansOuOn(x,y);
-  if(aTolu || aTolv) {
-    if(res != InternalSiDans(x-aTolu,y-aTolv)) return 0;
-    if(res != InternalSiDans(x+aTolu,y-aTolv)) return 0;
-    if(res != InternalSiDans(x-aTolu,y+aTolv)) return 0;
-    if(res != InternalSiDans(x+aTolu,y+aTolv)) return 0; 
+    std::cout << std::endl << "mkface ff pl wirsrc" << std::endl;
+    std::cout << "v2d; pcurve ff" << std::endl;
+
+    std::cout << "--- Dump of CSLib_Class2d polygon --" << std::endl << std::endl;
   }
-  return((res)? 1: -1);
-}
-//=======================================================================
-//function : InternalSiDans
-//purpose  : 
-//=======================================================================
-Standard_Integer CSLib_Class2d::InternalSiDans(const Standard_Real Px,
-					       const Standard_Real Py) const
-{ 
-  Standard_Integer nbc, i, ip1, SH, NH;
-  Standard_Real *Pnts2dX, *Pnts2dY;
-  Standard_Real  x, y, nx, ny;
-  //
-  nbc = 0;
-  i   = 0;
-  ip1 = 1;
-  Pnts2dX = (Standard_Real *)MyPnts2dX;
-  Pnts2dY = (Standard_Real *)MyPnts2dY;
-  x   = (Pnts2dX[i]-Px);
-  y   = (Pnts2dY[i]-Py);
-  SH  = (y<0.)? -1 : 1;
-  //
-  for(i=0; i<N ; i++,ip1++) { 
-    nx = Pnts2dX[ip1] - Px;
-    ny = Pnts2dY[ip1] - Py;
-    
-    NH = (ny<0.)? -1 : 1;
-    if(NH!=SH) { 
-      if(x>0. && nx>0.) {
-	nbc++;
-      }
-      else { 
-	if(x>0.0 || nx>0.) { 
-	  if((x-y*(nx-x)/(ny-y))>0.) {
-	    nbc++;
-	  }
-	}
-      }
-      SH = NH;
-    }
-    x = nx; y = ny;
+#endif
+
+  // The source polygon is translated.
+  // So, classified point has (0, 0) - coordinates.
+  
+  Standard_Real aPrevX = myPnts2d(0).X() - thePx,
+                aPrevY = myPnts2d(0).Y() - thePy;
+
+  if ((Abs(aPrevX) <= theTolU) && (Abs(aPrevY) <= theTolV))
+  {
+    //If the classified point is in the vertex of
+    //the polygon
+    return PolyOn;
   }
-  return(nbc&1);
-}
-//modified by NIZNHY-PKV Fri Jan 15 09:03:48 2010f
-//=======================================================================
-//function : InternalSiDansOuOn
-//purpose  : same code as above + test on ON (return(-1) in this case
-//=======================================================================
-Standard_Integer CSLib_Class2d::InternalSiDansOuOn(const Standard_Real Px,
-						   const Standard_Real Py) const 
-{ 
-  Standard_Integer nbc, i, ip1, SH, NH, iRet;
-  Standard_Real *Pnts2dX, *Pnts2dY;
-  Standard_Real x, y, nx, ny, aX;
-  Standard_Real aYmin;
-  //
-  nbc = 0;
-  i   = 0;
-  ip1 = 1;
-  Pnts2dX = (Standard_Real *)MyPnts2dX;
-  Pnts2dY = (Standard_Real *)MyPnts2dY;
-  x   = (Pnts2dX[i]-Px);
-  y   = (Pnts2dY[i]-Py);
-  aYmin=y;
-  SH  = (y<0.)? -1 : 1;
-  for(i=0; i<N ; i++, ip1++) { 
-   
-    nx = Pnts2dX[ip1] - Px;
-    ny = Pnts2dY[ip1] - Py;
-    //-- le 14 oct 97 
-    if(nx<Tolu && nx>-Tolu && ny<Tolv && ny>-Tolv) { 
-      iRet=-1;
-      return iRet;
-    }
-    //find Y coordinate of polyline for current X gka
-    //in order to detect possible status ON
-    Standard_Real aDx = (Pnts2dX[ip1] - Pnts2dX[ip1-1]);
-    if( (Pnts2dX[ip1-1] - Px) * nx < 0.)
+
+  const Standard_Real aNullTolV = Epsilon(myVmax - myVmin);
+
+  CSLib_Class2d::PolyState aRetVal = PolyOut;
+
+  const Standard_Integer aN = myPnts2d.Size();
+  for (Standard_Integer i = 1; i < aN; i++)
+  {
+    const Standard_Real aNewX = myPnts2d(i).X() - thePx,
+                        aNewY = myPnts2d(i).Y() - thePy;
+
+    const Standard_Real aDx = aNewX - aPrevX;
+    const Standard_Real aDy = aNewY - aPrevY;
+
+    if ((Abs(aDx) < gp::Resolution()) && (Abs(aDy) < gp::Resolution()))
+      continue;
+
+    if (Abs(aNewY) <= theTolV)
     {
-     
-      Standard_Real aCurPY =  Pnts2dY[ip1] - (Pnts2dY[ip1] - Pnts2dY[ip1-1])/aDx *nx;
-      Standard_Real aDeltaY = aCurPY - Py;
-      if(aDeltaY >= -Tolv && aDeltaY <= Tolv)
+      // The ray goes through some vertex of the polygon
+
+      if (Abs(aPrevY) < theTolV)
       {
-         iRet=-1;
-         return iRet;
+        // Tangential case. Must be investigated by other methods.
+        return (PolyState) 0;
       }
-    }
-    //
-      
-    NH = (ny<0.)? -1 : 1;
-    if(NH!=SH) { 
-      if(x>0. && nx>0.) {
-	nbc++;
+
+      if (Abs(aNewX) <= theTolU)
+      {
+        //If the classified point is in the vertex of
+        //the polygon
+        return PolyOn;
       }
-      else { 
-	if(x>0. || nx>0.) { 
-	  aX=x-y*(nx-x)/(ny-y);
-	  if(aX>0.){
-	    nbc++;
-	  }
-	}
+
+      if ((Abs(aNewY) <= aNullTolV) && (aNewX > 0.0))
+      {
+        // Ray goes exactly through the vertex of the polygon.
+
+        Standard_Real aY1 = aNewY;
+        if (i < aN - 1)
+        {
+          aY1 = myPnts2d(i + 1).Y() - thePy;
+        }
+        else
+        {
+          aY1 = myPnts2d(myPnts2d.Lower() + 1).Y() - thePy;
+        }
+
+        if (aY1*aPrevY < 0.0)
+        {
+          // Case like this
+
+          //        o
+          //      o
+          //x___o_____
+          //    *
+          //    *
+          //    * 
+
+          // x - the classified point;
+          // ___ - ray Y=thePy
+          // *** and ooo - adjacent segments of polygon
+
+          //Change status IN <--> OUT;
+          aRetVal = (PolyState) -aRetVal;
+        }
+
+        // Case like this
+
+        //x________ 
+        //     *o
+        //    *  o
+        //   *    o
+
+        // must be ignored.
+
+        if (IsOn(theTolU, theTolV, aPrevX, aPrevY, aDx, aDy))
+        {
+          return PolyOn;
+        }
+
+        aPrevX = aNewX;
+        aPrevY = aNewY;
+        continue;
       }
-      SH = NH;
     }
-    else {// y has same sign as ny  
-      if (ny<aYmin) {
-	aYmin=ny;
+
+    if (IsOn(theTolU, theTolV, aPrevX, aPrevY, aDx, aDy))
+    {
+      return PolyOn;
+    }
+
+    if (Abs(aPrevY) <= aNullTolV)
+    {
+      // Ray goes exactly through the vertex of the polygon.
+      // This case was processed earlier.
+
+      aPrevX = aNewX;
+      aPrevY = aNewY;
+      continue;
+    }
+
+    if (aNewY*aPrevY <= 0.0)
+    {
+      // The current segment intersects the line Y=thePy.
+      // X-coord. of the intersection point is
+      const Standard_Real aXi = aPrevX - aPrevY*aDx / aDy;
+
+      //Note.
+      // (aDy==0.0) if and only if (aNewY==aPrevY).
+      // At that, (aNewY*aPrevY <= 0.0) <==> (aNewY==aPrevY==0.0).
+      // Therefore, the condition above must be satisfied and
+      // the method will return 0.
+      // Consequently, here (aDy != 0.0) and aXi is found unambiguously.
+
+      if (aXi > 0.0)
+      {
+        // The current segment intersects the ray Y=thePy
+
+        //Change status IN <--> OUT;
+        aRetVal = (PolyState) -aRetVal;
       }
     }
-    x = nx; y = ny; 
-  }// for(i=0; i<N ; i++,ip1++) { 
- 
-  iRet=nbc&1;
-  return iRet;
-}
-//modified by NIZNHY-PKV Fri Jan 15 09:03:55 2010t
-//=======================================================================
-//function : Copy
-//purpose  : 
-//=======================================================================
-const CSLib_Class2d& CSLib_Class2d::Copy(const CSLib_Class2d& ) const 
-{ 
-#ifdef OCCT_DEBUG
-  cerr<<"Copy not allowed in CSLib_Class2d"<<endl;
-#endif
-  throw Standard_ConstructionError();
+
+    aPrevX = aNewX;
+    aPrevY = aNewY;
+  }
+
+  return aRetVal;
 }
+
 //=======================================================================
-//function : Transform2d
-//purpose  : 
+//function : IsOn
+//purpose  : If the line (which the current segment lies in) has
+//            the location L(thePrevX, thePrevY) and the direction
+//            d{theDx, theDy} then the parameter of the classified
+//            point (0, 0) on the line (i.e. the projection point) is
+//              t = (d*V)/|| d || = -(aPrevX*aDx+aPrevY*aDy)/|| d ||,
+//            where V{-thePrevX, -thePrevY} is the vector joining L with
+//            the classified point (0, 0).
+//            If the projection point is IN the current segment then
+//            the inequation
+//              0 <= t <= || d ||
+//            must be satisfied.
+//            Or
+//              0 <= -(thePrevX*theDx+thePrevY*theDy) <= || d ||^2.
 //=======================================================================
-Standard_Real Transform2d(const Standard_Real u,
-			  const Standard_Real umin,
-			  const Standard_Real umaxmumin) 
-{ 
-  if(umaxmumin>1e-10) { 
-    Standard_Real U = (u-umin)/umaxmumin;
-    return U;
-  }
-  else { 
-    return u;
+static inline Standard_Boolean IsOn(const Standard_Real theTolU,
+                                    const Standard_Real theTolV,
+                                    const Standard_Real thePrevX,
+                                    const Standard_Real thePrevY,
+                                    const Standard_Real theDx,
+                                    const Standard_Real theDy)
+{
+  //Square length of the considered segment
+  //aSqL != 0 (see algorithm of polygon building in constructor).
+  const Standard_Real aSqL = theDx*theDx + theDy*theDy;
+  const Standard_Real aDP = theDx*thePrevX + theDy*thePrevY;
+  if ((-aSqL <= aDP) && (aDP <= 0.0))
+  {
+    // The projection point has coordinates
+    //    L + t*d/|| d || = L - d*(aPrevX*aDx+aPrevY*aDy)/aSqL
+
+    const Standard_Real aXNear = thePrevX - aDP*theDx / aSqL;
+    const Standard_Real aYNear = thePrevY - aDP*theDy / aSqL;
+
+    if ((Abs(aXNear) <= theTolU) && (Abs(aYNear) <= theTolV))
+    {
+      // The distance between the projection point and 
+      // the classified point (0, 0) is in the given tolerances
+      return Standard_True;
+    }
   }
+
+  return Standard_False;
 }
diff --git a/src/CSLib/CSLib_Class2d.hxx b/src/CSLib/CSLib_Class2d.hxx
index 96478dd..9495c5a 100644
--- a/src/CSLib/CSLib_Class2d.hxx
+++ b/src/CSLib/CSLib_Class2d.hxx
@@ -21,75 +21,78 @@
 #include <Standard_DefineAlloc.hxx>
 #include <Standard_Handle.hxx>
 
-#include <Standard_Address.hxx>
-#include <Standard_Real.hxx>
-#include <Standard_Integer.hxx>
+#include <NCollection_Array1.hxx>
 #include <TColgp_Array1OfPnt2d.hxx>
 class gp_Pnt2d;
 
 
-
-//! *** Class2d    : Low level algorithm for 2d classification
-//! this class was moved from package BRepTopAdaptor
+//! Performs the classification of the given 2D-point
+//! relatively to the closed 2D-polygon.
+//! The orientation of the polygon is NOT taken into account.
+//! Returns ON-status if computation is impossible.
 class CSLib_Class2d 
 {
 public:
 
   DEFINE_STANDARD_ALLOC
 
+  enum PolyState
+  {
+    PolyOut = -1,
+    PolyOn = 0,
+    PolyIn = 1
+  };
+
+  //! Constructs the 2D-polygon.
+  //! theTP2d is the set of the vertices (closed polygon
+  //! will always be created inside of this constructor;
+  //! consequently, there is no point in repeating first and
+  //! last point in theTP2d).
+  //! theTolu and theTolv are tolerances.
+  //! theUmin, theVmin, theUmax, theVmax are
+  //! UV-bounds of the polygon.
+  Standard_EXPORT CSLib_Class2d(const TColgp_Array1OfPnt2d& theTP2d,
+                                const Standard_Real theTolu,
+                                const Standard_Real theTolv,
+                                const Standard_Real theUmin,
+                                const Standard_Real theVmin,
+                                const Standard_Real theUmax,
+                                const Standard_Real theVmax);
   
-  Standard_EXPORT CSLib_Class2d(const TColgp_Array1OfPnt2d& TP, const Standard_Real aTolu, const Standard_Real aTolv, const Standard_Real umin, const Standard_Real vmin, const Standard_Real umax, const Standard_Real vmax);
-  
-  Standard_EXPORT Standard_Integer SiDans (const gp_Pnt2d& P) const;
-  
-  Standard_EXPORT Standard_Integer SiDans_OnMode (const gp_Pnt2d& P, const Standard_Real Tol) const;
+  //! Classifies theP relatively to the polygon.
+  //! Uses internal tolerances (myTolU, myTolV).
+  Standard_EXPORT PolyState Classify(const gp_Pnt2d& theP) const;
   
-  Standard_EXPORT Standard_Integer InternalSiDans (const Standard_Real X, const Standard_Real Y) const;
-  
-  Standard_EXPORT Standard_Integer InternalSiDansOuOn (const Standard_Real X, const Standard_Real Y) const;
-  
-  Standard_EXPORT const CSLib_Class2d& Copy (const CSLib_Class2d& Other) const;
-const CSLib_Class2d& operator= (const CSLib_Class2d& Other) const
-{
-  return Copy(Other);
-}
+  //! Classifies theP relatively to the polygon.
+  //! Uses given tolerances (theTolU, theTolV).
+  Standard_EXPORT PolyState Classify(const gp_Pnt2d& theP,
+                                     const Standard_Real theTolU,
+                                     const Standard_Real theTolV) const;
   
-  Standard_EXPORT void Destroy();
-~CSLib_Class2d()
-{
-  Destroy();
-}
-
-
-
-
 protected:
 
+  //! Classifies theP relatively to the polygon.
+  //! Uses internal tolerances (myTolU, myTolV).
+  //! Realizes the algorithm itself.
+  Standard_EXPORT PolyState InternalClass(const Standard_Real thePx,
+                                          const Standard_Real thePy,
+                                          const Standard_Real theTolU,
+                                          const Standard_Real theTolV) const;
 
-
-
+  //! Assignment operator is disabled for this class.
+  const CSLib_Class2d& operator= (const CSLib_Class2d& Other) const;
 
 private:
+  
+  //! Stores set of vertices of the given 2D-polygons
+  TColgp_Array1OfPnt2d myPnts2d;
 
+  //! Tolerances
+  Standard_Real myTolU, myTolV;
 
-
-  Standard_Address MyPnts2dX;
-  Standard_Address MyPnts2dY;
-  Standard_Real Tolu;
-  Standard_Real Tolv;
-  Standard_Integer N;
-  Standard_Real Umin;
-  Standard_Real Vmin;
-  Standard_Real Umax;
-  Standard_Real Vmax;
-
+  //! UV-bounds of the polygon
+  Standard_Real myUmin, myUmax, myVmin, myVmax;
 
 };
 
-
-
-
-
-
-
 #endif // _CSLib_Class2d_HeaderFile
diff --git a/src/ChFi3d/ChFi3d_Builder_0.cxx b/src/ChFi3d/ChFi3d_Builder_0.cxx
index fd166d3..19c8526 100644
--- a/src/ChFi3d/ChFi3d_Builder_0.cxx
+++ b/src/ChFi3d/ChFi3d_Builder_0.cxx
@@ -2951,8 +2951,7 @@ Standard_Real ChFi3d_EvalTolReached(const Handle(Adaptor3d_HSurface)& S1,
 //function : trsfsurf
 //purpose  : 
 //=======================================================================
-Handle(Geom_Surface) trsfsurf(const Handle(Adaptor3d_HSurface)& HS,
-  Handle(Adaptor3d_TopolTool)&      /*dom*/)
+Handle(Geom_Surface) trsfsurf(const Handle(Adaptor3d_HSurface)& HS)
 {
   //Pour l utilisation des domaines voir avec BUBUCH!!
   Handle(Geom_Surface) res;
@@ -3184,9 +3183,8 @@ Standard_Boolean ChFi3d_ComputeCurves(const Handle(Adaptor3d_HSurface)&   S1,
   }
   else {
     // here GeomInt is approached.
-    Handle(Adaptor3d_TopolTool) dom1,dom2;
-    Handle(Geom_Surface) gs1 = trsfsurf(S1,dom1);
-    Handle(Geom_Surface) gs2 = trsfsurf(S2,dom2);
+    Handle(Geom_Surface) gs1 = trsfsurf(S1);
+    Handle(Geom_Surface) gs2 = trsfsurf(S2);
     Standard_Integer nbl ;
     if(!gs1.IsNull() && !gs2.IsNull()) {
       GeomInt_IntSS inter;
diff --git a/src/ChFi3d/ChFi3d_Builder_2.cxx b/src/ChFi3d/ChFi3d_Builder_2.cxx
index c7d003f..da94ada 100644
--- a/src/ChFi3d/ChFi3d_Builder_2.cxx
+++ b/src/ChFi3d/ChFi3d_Builder_2.cxx
@@ -858,14 +858,14 @@ void ChFi3d_Builder::StartSol(const Handle(ChFiDS_Stripe)&      Stripe,
       ResV = AS.VResolution(TolE);
       derive *= 2*(Abs(derive.X())*ResU + Abs(derive.Y())*ResV);
       P2d = P1.Translated(derive);
-      if (I1->Classify(P2d, Min(ResU, ResV), 0)== TopAbs_IN) {
-	P1 = P2d;
+      if (I1->Classify(P2d, TolE, Standard_False) == TopAbs_IN) {
+        P1 = P2d;
       }
       else {
-	 P2d = P1.Translated(-derive);
-	 if (I1->Classify(P2d, Min(ResU, ResV), 0)== TopAbs_IN) {
-	   P1 = P2d;
-	 }
+         P2d = P1.Translated(-derive);
+         if (I1->Classify(P2d, TolE, Standard_False) == TopAbs_IN) {
+           P1 = P2d;
+         }
       }
     }
     if(f1.IsSame(f2)) cured.Orientation(TopAbs_REVERSED);
diff --git a/src/ChFi3d/ChFi3d_Builder_SpKP.cxx b/src/ChFi3d/ChFi3d_Builder_SpKP.cxx
index a4b2cd2..2d79670 100644
--- a/src/ChFi3d/ChFi3d_Builder_SpKP.cxx
+++ b/src/ChFi3d/ChFi3d_Builder_SpKP.cxx
@@ -780,7 +780,7 @@ Standard_Boolean ChFi3d_Builder::SplitKPart
     // It is checked if the point 2d of the degenerated edge is in the face.
     if (C1.IsNull()) {
       gp_Pnt2d p2d1 = CD->Get2dPoints(0,1);
-      TopAbs_State situ = I1->Classify(p2d1,1.e-8,0);
+      TopAbs_State situ = I1->Classify(p2d1,Precision::Confusion(),Standard_False);
       if(situ == TopAbs_OUT) return Standard_False;
     }
 
@@ -815,7 +815,7 @@ Standard_Boolean ChFi3d_Builder::SplitKPart
     // It is checked if the point 2d of the degenerated is in the face.
     if (C2.IsNull()) {
       gp_Pnt2d p2d2 = CD->Get2dPoints(0,2);
-      TopAbs_State situ = I2->Classify(p2d2,1.e-8,0);
+      TopAbs_State situ = I2->Classify(p2d2,Precision::Confusion(),Standard_False);
       if(situ == TopAbs_OUT) return Standard_False;
     }
 
diff --git a/src/ChFi3d/ChFi3d_ChBuilder_C3.cxx b/src/ChFi3d/ChFi3d_ChBuilder_C3.cxx
index 7dca1c2..b5df8a0 100644
--- a/src/ChFi3d/ChFi3d_ChBuilder_C3.cxx
+++ b/src/ChFi3d/ChFi3d_ChBuilder_C3.cxx
@@ -354,10 +354,8 @@ void ChFi3d_ChBuilder::PerformThreeCorner(const Standard_Integer Jndex)
   Handle(BRepAdaptor_HSurface) Fac = new BRepAdaptor_HSurface(face[pivot]);
   Handle(GeomAdaptor_HSurface) 
     bidsurf = new GeomAdaptor_HSurface(Fac->ChangeSurface().Surface());
-  Handle(Adaptor3d_TopolTool)  IFac = new Adaptor3d_TopolTool(bidsurf);
 
   Handle(GeomAdaptor_HSurface) Surf = ChFi3d_BoundSurf (DStr,fdpiv,jf[pivot][deb],jf[pivot][fin]);
-  Handle(Adaptor3d_TopolTool) ISurf = new Adaptor3d_TopolTool(Surf);
  
   // Creation of a new Stripe for the corner
   Handle(ChFiDS_Stripe) corner = new ChFiDS_Stripe();
diff --git a/src/ChFi3d/ChFi3d_FilBuilder_C3.cxx b/src/ChFi3d/ChFi3d_FilBuilder_C3.cxx
index 732c6cf..cd86e3a 100644
--- a/src/ChFi3d/ChFi3d_FilBuilder_C3.cxx
+++ b/src/ChFi3d/ChFi3d_FilBuilder_C3.cxx
@@ -438,8 +438,7 @@ void ChFi3d_FilBuilder::PerformThreeCorner(const Standard_Integer Jndex)
   // the border.  
   Handle(GeomAdaptor_HSurface) 
     bidsurf = new GeomAdaptor_HSurface(Fac->ChangeSurface().Surface());
-  Handle(Adaptor3d_TopolTool) 
-    IFac = new Adaptor3d_TopolTool(bidsurf);
+  Handle(Adaptor3d_TopolTool) IFac = new Adaptor3d_TopolTool(bidsurf);
   // end of the attempt.
   Handle(Adaptor3d_TopolTool) ISurf = new Adaptor3d_TopolTool(Surf);
   Handle(ChFiDS_Stripe) corner = new ChFiDS_Stripe();
